Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2c.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2c.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/config_thread_8_execute_2c.cfg	(revision 88)
@@ -0,0 +1,98 @@
+Execute_loop
+1	1	+1	# nb_read_unit                              
+1	1	+1	# nb_functionnal_unit                       
+1	1	+1	# nb_load_store_unit                        
+1	1	+1	# nb_write_unit                             
+1	1	+1	# nb_context                                
+1	1	+1	# nb_front_end                              
+8	8	+1	# nb_ooo_engine                             
+32	32	+1	# nb_packet                                 
+32	32	+1	# size_general_data                         
+2	2	+1	# size_special_data                         
+4	4	*4	# size_read_queue                            [0]       [nb_read_unit]
+4	4	*4	# size_reservation_station                   [0]       [nb_read_unit]
+2	2	+1	# nb_inst_retire                             [0]       [nb_read_unit]
+1	1	+1	# nb_inst_functionnal_unit		     [0]       [nb_inst_functionnal]
+4	4	*2	# size_store_queue                           [0]       [nb_load_store_unit]
+4	4	*2	# size_load_queue                            [0]       [nb_load_store_unit]
+4	4	*2	# size_speculative_access_queue              [0]       [nb_load_store_unit]
+1	1	+1	# nb_port_check                              [0]       [nb_load_store_unit]
+2	2	+1	# speculative_load                           [0]       [nb_load_store_unit]
+0	0	+1	# nb_bypass_memory                           [0]       [nb_load_store_unit]
+1	1	+1	# nb_cache_port                              [0]       [nb_load_store_unit]
+1	1	+1	# nb_inst_memory                             [0]       [nb_load_store_unit]
+4	4	*4	# size_write_queue                           [0]       [nb_write_unit]
+4	4	*4	# size_execute_queue                         [0]       [nb_write_unit]
+2	2	+1	# nb_bypass_write                            [0]       [nb_write_unit]
+4	4	+1	# nb_gpr_bank                                	       
+1	1	+1	# nb_gpr_port_read_by_bank                   	       
+1	1	+1	# nb_gpr_port_write_by_bank                  	       
+4	4	+1	# nb_spr_bank                                	       
+1	1	+1	# nb_spr_port_read_by_bank                   	       
+1	1	+1	# nb_spr_port_write_by_bank                  	       
+64	64	+1	# nb_general_register                        [0]       [nb_ooo_engine]		  
+64	64	+1	# nb_general_register                        [1]       [nb_ooo_engine]		  
+64	64	+1	# nb_general_register                        [2]       [nb_ooo_engine]		  
+64	64	+1	# nb_general_register                        [3]       [nb_ooo_engine]		  
+64	64	+1	# nb_general_register                        [4]       [nb_ooo_engine]		  
+64	64	+1	# nb_general_register                        [5]       [nb_ooo_engine]		  
+64	64	+1	# nb_general_register                        [6]       [nb_ooo_engine]		  
+64	64	+1	# nb_general_register                        [7]       [nb_ooo_engine]		  
+16	16	+1	# nb_special_register                        [0]       [nb_ooo_engine]		  
+16	16	+1	# nb_special_register                        [1]       [nb_ooo_engine]		  
+16	16	+1	# nb_special_register                        [2]       [nb_ooo_engine]		  
+16	16	+1	# nb_special_register                        [3]       [nb_ooo_engine]		  
+16	16	+1	# nb_special_register                        [4]       [nb_ooo_engine]		  
+16	16	+1	# nb_special_register                        [5]       [nb_ooo_engine]		  
+16	16	+1	# nb_special_register                        [6]       [nb_ooo_engine]		  
+16	16	+1	# nb_special_register                        [7]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_insert_rob                         [0]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_insert_rob                         [1]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_insert_rob                         [2]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_insert_rob                         [3]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_insert_rob                         [4]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_insert_rob                         [5]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_insert_rob                         [6]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_insert_rob                         [7]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_retire_rob                         [0]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_retire_rob                         [1]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_retire_rob                         [2]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_retire_rob                         [3]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_retire_rob                         [4]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_retire_rob                         [5]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_retire_rob                         [6]       [nb_ooo_engine]		  
+1	1	+1	# nb_inst_retire_rob                         [7]       [nb_ooo_engine]		  
+1	1	+1	# execution_unit_to_write_unit_priority                                         
+1	1	+1	# execution_unit_to_write_unit_table_routing [0][0][0] [nb_execute_unit][nb_execute_unit_port][nb_write_unit]
+1	1	+1	# execution_unit_to_write_unit_table_routing [1][0][0] [nb_execute_unit][nb_execute_unit_port][nb_write_unit]
+1	1	+1	# execution_unit_to_write_unit_table_thread  [0][0]    [nb_write_unit][nb_thread]	  
+1	1	+1	# execution_unit_to_write_unit_table_thread  [0][1]    [nb_write_unit][nb_thread]	  
+1	1	+1	# execution_unit_to_write_unit_table_thread  [0][2]    [nb_write_unit][nb_thread]	  
+1	1	+1	# execution_unit_to_write_unit_table_thread  [0][3]    [nb_write_unit][nb_thread]	  
+1	1	+1	# execution_unit_to_write_unit_table_thread  [0][4]    [nb_write_unit][nb_thread]	  
+1	1	+1	# execution_unit_to_write_unit_table_thread  [0][5]    [nb_write_unit][nb_thread]	  
+1	1	+1	# execution_unit_to_write_unit_table_thread  [0][6]    [nb_write_unit][nb_thread]	  
+1	1	+1	# execution_unit_to_write_unit_table_thread  [0][7]    [nb_write_unit][nb_thread]	  
+1	1	+1	# read_unit_to_execution_unit_priority                                          
+1	1	+1	# read_unit_to_execution_unit_table_routing  [0][0][0] [nb_read_unit][nb_execute_unit][nb_execute_unit_port]
+1	1	+1	# read_unit_to_execution_unit_table_routing  [0][1][0] [nb_read_unit][nb_execute_unit][nb_execute_unit_port]
+1	1	+1	# read_unit_to_execution_unit_table_thread   [0][0]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [0][1]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [0][2]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [0][3]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [0][4]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [0][5]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [0][6]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [0][7]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [1][0]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [1][1]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [1][2]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [1][3]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [1][4]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [1][5]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [1][6]    [nb_execute_unit][nb_thread]    
+1	1	+1	# read_unit_to_execution_unit_table_thread   [1][7]    [nb_execute_unit][nb_thread]    
+0	0	+1      # is_load_store_unit                         [0]       [nb_execute_unit]
+1	1	+1      # is_load_store_unit                         [1]       [nb_execute_unit]
+0       0       +1      # translate_num_execute_unit                 [0]       [nb_execute_unit]
+0       0       +1      # translate_num_execute_unit                 [1]       [nb_execute_unit]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h	(revision 88)
@@ -16,4 +16,5 @@
 
 #include "Common/include/Time.h"
+#include "Behavioural/include/Selftest.h"
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Execute_loop.h"
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 88)
@@ -14,42 +14,48 @@
   err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
   err (_("list_params is :\n"));
-  err (_(" * nb_read_unit                                                               (uint32_t           )\n"));
-  err (_(" * nb_functionnal_unit                                                        (uint32_t           )\n"));
-  err (_(" * nb_load_store_unit                                                         (uint32_t           )\n"));
-  err (_(" * nb_write_unit                                                              (uint32_t           )\n"));
-  err (_(" * nb_context                                                                 (uint32_t           )\n"));
-  err (_(" * nb_front_end                                                               (uint32_t           )\n"));
-  err (_(" * nb_ooo_engine                                                              (uint32_t           )\n"));
-  err (_(" * nb_packet                                                                  (uint32_t           )\n"));
-  err (_(" * size_general_data                                                          (uint32_t           )\n"));
-  err (_(" * size_special_data                                                          (uint32_t           )\n"));
-  err (_(" * size_read_queue                           [read_unit]                      (uint32_t           )\n"));
-  err (_(" * size_reservation_station                  [read_unit]                      (uint32_t           )\n"));
-  err (_(" * nb_inst_retire                            [read_unit]                      (uint32_t           )\n"));
-  err (_(" * size_store_queue                          [load_store_unit]                (uint32_t           )\n"));
-  err (_(" * size_load_queue                           [load_store_unit]                (uint32_t           )\n"));
-  err (_(" * size_speculative_access_queue             [load_store_unit]                (uint32_t           )\n"));
-  err (_(" * nb_port_check                             [load_store_unit]                (uint32_t           )\n"));
-  err (_(" * speculative_load                          [load_store_unit]                (Tspeculative_load_t)\n"));
-  err (_(" * nb_bypass_memory                          [load_store_unit]                (uint32_t           )\n"));
-  err (_(" * size_write_queue                          [write_unit]                     (uint32_t           )\n"));
-  err (_(" * size_execute_queue                        [write_unit]                     (uint32_t           )\n"));
-  err (_(" * nb_bypass_write                           [write_unit]                     (uint32_t           )\n"));
-  err (_(" * nb_gpr_bank                                                                (uint32_t           )\n"));
-  err (_(" * nb_gpr_port_read_by_bank                                                   (uint32_t           )\n"));
-  err (_(" * nb_gpr_port_write_by_bank                                                  (uint32_t           )\n"));
-  err (_(" * nb_spr_bank                                                                (uint32_t           )\n"));
-  err (_(" * nb_spr_port_read_by_bank                                                   (uint32_t           )\n"));
-  err (_(" * nb_spr_port_write_by_bank                                                  (uint32_t           )\n"));
-  err (_(" * nb_general_register                       [nb_ooo_engine]                  (uint32_t           )\n"));
-  err (_(" * nb_special_register                       [nb_ooo_engine]                  (uint32_t           )\n"));
-  err (_(" * nb_inst_insert_rob                        [nb_ooo_engine]                  (uint32_t           )\n"));
-  err (_(" * nb_inst_retire_rob                        [nb_ooo_engine]                  (uint32_t           )\n"));
-  err (_(" * execution_unit_to_write_unit_priority                                      (Tpriority_t        )\n"));
-  err (_(" * execution_unit_to_write_unit_table_routing[nb_execute_unit][nb_write_unit] (bool               )\n"));
-  err (_(" * execution_unit_to_write_unit_table_thread [nb_write_unit][nb_thread]       (bool               )\n"));
-  err (_(" * read_unit_to_execution_unit_priority                                       (Tpriority_t        )\n"));
-  err (_(" * read_unit_to_execution_unit_table_routing [nb_read_unit][nb_execute_unit]  (bool               )\n"));
-  err (_(" * read_unit_to_execution_unit_table_thread  [nb_execute_unit][nb_thread]     (bool               )\n"));
+  err (_(" * nb_read_unit                                                                                     (uint32_t           )\n"));
+  err (_(" * nb_functionnal_unit                                                                              (uint32_t           )\n"));
+  err (_(" * nb_load_store_unit                                                                               (uint32_t           )\n"));
+  err (_(" * nb_write_unit                                                                                    (uint32_t           )\n"));
+  err (_(" * nb_context                                                                                       (uint32_t           )\n"));
+  err (_(" * nb_front_end                                                                                     (uint32_t           )\n"));
+  err (_(" * nb_ooo_engine                                                                                    (uint32_t           )\n"));
+  err (_(" * nb_packet                                                                                        (uint32_t           )\n"));
+  err (_(" * size_general_data                                                                                (uint32_t           )\n"));
+  err (_(" * size_special_data                                                                                (uint32_t           )\n"));
+  err (_(" * size_read_queue                           [nb_read_unit]                                         (uint32_t           )\n"));
+  err (_(" * size_reservation_station                  [nb_read_unit]                                         (uint32_t           )\n"));
+  err (_(" * nb_inst_retire                            [nb_read_unit]                                         (uint32_t           )\n"));
+  err (_(" * nb_inst_functionnal_unit                  [nb_functionnal_unit]                                  (uint32_t           )\n"));
+  err (_(" * size_store_queue                          [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * size_load_queue                           [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * size_speculative_access_queue             [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * nb_port_check                             [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * speculative_load                          [nb_load_store_unit]                                   (Tspeculative_load_t)\n"));
+  err (_(" * nb_bypass_memory                          [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * nb_cache_port                             [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * nb_inst_memory                            [nb_load_store_unit]                                   (uint32_t           )\n"));
+  err (_(" * size_write_queue                          [nb_write_unit]                                        (uint32_t           )\n"));
+  err (_(" * size_execute_queue                        [nb_write_unit]                                        (uint32_t           )\n"));
+  err (_(" * nb_bypass_write                           [nb_write_unit]                                        (uint32_t           )\n"));
+  err (_(" * nb_gpr_bank                                                                                      (uint32_t           )\n"));
+  err (_(" * nb_gpr_port_read_by_bank                                                                         (uint32_t           )\n"));
+  err (_(" * nb_gpr_port_write_by_bank                                                                        (uint32_t           )\n"));
+  err (_(" * nb_spr_bank                                                                                      (uint32_t           )\n"));
+  err (_(" * nb_spr_port_read_by_bank                                                                         (uint32_t           )\n"));
+  err (_(" * nb_spr_port_write_by_bank                                                                        (uint32_t           )\n"));
+  err (_(" * nb_general_register                       [nb_ooo_engine]                                        (uint32_t           )\n"));
+  err (_(" * nb_special_register                       [nb_ooo_engine]                                        (uint32_t           )\n"));
+  err (_(" * nb_inst_insert_rob                        [nb_ooo_engine]                                        (uint32_t           )\n"));
+  err (_(" * nb_inst_retire_rob                        [nb_ooo_engine]                                        (uint32_t           )\n"));
+  err (_(" * execution_unit_to_write_unit_priority                                                            (Tpriority_t        )\n"));
+  err (_(" * execution_unit_to_write_unit_table_routing[nb_execute_unit][nb_execute_unit_port][nb_write_unit] (bool               )\n"));
+  err (_(" * execution_unit_to_write_unit_table_thread [nb_write_unit][nb_thread]                             (bool               )\n"));
+  err (_(" * read_unit_to_execution_unit_priority                                                             (Tpriority_t        )\n"));
+  err (_(" * read_unit_to_execution_unit_table_routing [nb_read_unit][nb_execute_unit][nb_execute_unit_port]  (bool               )\n"));
+  err (_(" * read_unit_to_execution_unit_table_thread  [nb_execute_unit][nb_thread]                           (bool               )\n"));
+  err (_(" * is_load_store_unit                        [nb_execute_unit]                                      (bool               )\n"));
+  err (_(" * translate_num_execute_unit                [nb_execute_unit]                                      (uint32_t           )\n"));
+
 
   exit (1);
@@ -62,4 +68,9 @@
 #endif
 {
+  // Command
+  for (int32_t i=0; i<argc; ++i)
+    msg("%s ",argv[i]);
+  msg("\n");
+  
   if (argc < 2+NB_PARAMS)
     usage (argc, argv);
@@ -84,19 +95,17 @@
   int32_t nb_params = (2+NB_PARAMS+
 		       3*nb_read_unit+
-		       6*nb_load_store_unit+
+		       1*nb_functionnal_unit+
+		       8*nb_load_store_unit+
 		       3*nb_write_unit+
 		       4*nb_ooo_engine+
-		       nb_execute_unit*nb_write_unit+
+// 		       sum_execute_unit_port*nb_write_unit+
 		       nb_write_unit*nb_thread+
-		       nb_read_unit*nb_execute_unit+
-		       nb_execute_unit*nb_thread);
-  
-  
-  
-  if (argc != nb_params)
-    {
-      msg(_("Need %d parameters."),nb_params);
-      usage (argc, argv);
-    }
+// 		       nb_read_unit*sum_execute_unit_port+
+		       nb_execute_unit*nb_thread+
+                       2*nb_execute_unit);
+  
+  if (argc <= nb_params)
+    usage (argc, argv);
+  
   uint32_t            * size_read_queue          = new uint32_t [nb_read_unit];
   for (uint32_t i=0; i<nb_read_unit; i++)
@@ -111,4 +120,8 @@
     nb_inst_retire [i] = atoi(argv[x++]);
 
+  uint32_t            * nb_inst_functionnal_unit = new uint32_t [nb_functionnal_unit];
+  for (uint32_t i=0; i<nb_functionnal_unit; i++)
+    nb_inst_functionnal_unit [i] = atoi(argv[x++]);
+
   uint32_t          * size_store_queue              = new uint32_t [nb_load_store_unit];
   for (uint32_t i=0; i<nb_load_store_unit; i++)
@@ -134,4 +147,41 @@
   for (uint32_t i=0; i<nb_load_store_unit; i++)
     nb_bypass_memory              [i] = atoi(argv[x++]);
+
+  uint32_t          * nb_cache_port                 = new uint32_t [nb_load_store_unit];
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    nb_cache_port                 [i] = atoi(argv[x++]);
+
+  uint32_t          * nb_inst_memory                = new uint32_t [nb_load_store_unit];
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    nb_inst_memory                [i] = atoi(argv[x++]);
+
+
+  uint32_t sum_execute_unit_port = 0;
+  for (uint32_t i=0; i<nb_load_store_unit; i++)
+    sum_execute_unit_port += nb_inst_memory[i];
+  for (uint32_t i=0; i<nb_functionnal_unit; i++)
+    sum_execute_unit_port += nb_inst_functionnal_unit[i];
+
+  nb_params = (2+NB_PARAMS+
+	       3*nb_read_unit+
+	       1*nb_functionnal_unit+
+	       8*nb_load_store_unit+
+	       3*nb_write_unit+
+	       4*nb_ooo_engine+
+	       sum_execute_unit_port*nb_write_unit+
+	       nb_write_unit*nb_thread+
+	       nb_read_unit*sum_execute_unit_port+
+	       nb_execute_unit*nb_thread+
+               2*nb_execute_unit);
+  
+  if (argc != nb_params)
+    {
+      msg("nb_functionnal_unit   : %d\n",nb_functionnal_unit);
+      msg("nb_load_store_unit    : %d\n",nb_load_store_unit );
+      msg("sum_execute_unit_port : %d.\n",sum_execute_unit_port);
+      msg(_("Have %d parameters.\n"),argc     );
+      msg(_("Need %d parameters.\n"),nb_params);
+      usage (argc, argv);
+    }
 
   uint32_t * size_write_queue   = new uint32_t [nb_write_unit];
@@ -172,11 +222,20 @@
   Tpriority_t execution_unit_to_write_unit_priority = fromString<Tpriority_t>(argv[x++]);
 
-  bool ** execution_unit_to_write_unit_table_routing = new bool * [nb_execute_unit];
+  bool *** execution_unit_to_write_unit_table_routing = new bool ** [nb_execute_unit];
   for (uint32_t i=0; i<nb_execute_unit; i++)
     {
-      execution_unit_to_write_unit_table_routing [i] = new bool [nb_write_unit];
-      for (uint32_t j=0; j<nb_write_unit; j++)
-	execution_unit_to_write_unit_table_routing [i][j] = atoi(argv[x++]);
-    }
+      uint32_t nb_execute_unit_port = (i<nb_load_store_unit)?nb_inst_memory[i]:nb_inst_functionnal_unit[i-nb_load_store_unit];
+
+      execution_unit_to_write_unit_table_routing [i] = new bool * [nb_execute_unit_port];
+      
+      for (uint32_t j=0; j<nb_execute_unit_port; j++)
+	{
+	  execution_unit_to_write_unit_table_routing [i][j] = new bool [nb_write_unit];
+	  
+	  for (uint32_t k=0; k<nb_write_unit; k++)
+	    execution_unit_to_write_unit_table_routing [i][j][k] = atoi(argv[x++]);
+	}
+    }
+
   bool ** execution_unit_to_write_unit_table_thread = new bool * [nb_write_unit];
   for (uint32_t i=0; i<nb_write_unit; i++)
@@ -188,11 +247,18 @@
   Tpriority_t read_unit_to_execution_unit_priority  = fromString<Tpriority_t>(argv[x++]);
 
-  bool ** read_unit_to_execution_unit_table_routing = new bool * [nb_read_unit];
+  bool *** read_unit_to_execution_unit_table_routing = new bool ** [nb_read_unit];
   for (uint32_t i=0; i<nb_read_unit; i++)
     {
-      read_unit_to_execution_unit_table_routing [i] = new bool [nb_execute_unit];
+      read_unit_to_execution_unit_table_routing [i] = new bool * [nb_execute_unit];
       for (uint32_t j=0; j<nb_execute_unit; j++)
-	read_unit_to_execution_unit_table_routing [i][j] = atoi(argv[x++]);
-    }
+	{
+	  uint32_t nb_execute_unit_port = (j<nb_load_store_unit)?nb_inst_memory[j]:nb_inst_functionnal_unit[j-nb_load_store_unit];
+	  read_unit_to_execution_unit_table_routing [i][j] = new bool [nb_execute_unit_port];
+
+	  for (uint32_t k=0; k<nb_execute_unit_port; k++)
+	    read_unit_to_execution_unit_table_routing [i][j][k] = atoi(argv[x++]);
+	}
+    }
+
   bool ** read_unit_to_execution_unit_table_thread = new bool * [nb_execute_unit];
   for (uint32_t i=0; i<nb_execute_unit; i++)
@@ -202,8 +268,16 @@
 	read_unit_to_execution_unit_table_thread [i][j] =  atoi(argv[x++]);
     }
-  execute_timing_t *** timing = new execute_timing_t ** [nb_execute_unit];
-  
+
+  bool * is_load_store_unit = new bool [nb_execute_unit];
+  for (uint32_t i=0; i<nb_execute_unit; i++)
+    is_load_store_unit [i] = fromString<bool>(argv[x++]);
+
+  uint32_t * translate_num_execute_unit = new uint32_t [nb_execute_unit];
+  for (uint32_t i=0; i<nb_execute_unit; i++)
+    translate_num_execute_unit [i] = fromString<uint32_t>(argv[x++]);
+
+  execute_timing_t *** timing = new execute_timing_t ** [nb_functionnal_unit];
   // alloc and reset timing array
-  for (uint32_t i=0; i< nb_execute_unit; i++)
+  for (uint32_t i=0; i< nb_functionnal_unit; i++)
     {
       timing [i] = new execute_timing_t * [MAX_TYPE];
@@ -218,14 +292,15 @@
     }
   
-  for (uint32_t i=0; i< nb_load_store_unit; i++)
-    for (uint32_t k=0; k< MAX_OPERATION; k++)
-      timing[i][TYPE_MEMORY][k]._delay = timing[i][TYPE_MEMORY][k]._latence = 1;
   for (uint32_t i=0; i< nb_functionnal_unit; i++)
     for (uint32_t j=0; j< MAX_TYPE; j++)
-      if (j != TYPE_MEMORY)
-	for (uint32_t k=0; k< MAX_OPERATION; k++)
-	  timing[i+nb_load_store_unit][j][k]._delay = timing[i+nb_load_store_unit][j][k]._latence = 1;
-
-  morpheo::behavioural::custom::custom_information_t (*get_custom_information) (uint32_t) = &(morpheo::behavioural::custom::default_get_custom_information);
+      {
+	if ( (j != TYPE_MEMORY) and
+	     not ((i!=0) and ((j == TYPE_SPECIAL) or
+			      (j == TYPE_CUSTOM))))
+	  for (uint32_t k=0; k< MAX_OPERATION; k++)
+	    timing[i][j][k]._delay = timing[i][j][k]._latence = 1;
+      }
+
+  morpheo::behavioural::custom::custom_information_t (*get_custom_information) (void) = &(morpheo::behavioural::custom::default_get_custom_information);
 
   try 
@@ -247,5 +322,6 @@
 	 size_reservation_station                      ,
 	 nb_inst_retire                                ,
-	 
+
+	 nb_inst_functionnal_unit                      ,
 	 timing                                        ,
 	 get_custom_information                        ,
@@ -256,6 +332,8 @@
 	 nb_port_check                                 ,
 	 speculative_load                              ,
-	 
 	 nb_bypass_memory                              ,
+	 nb_cache_port                                 ,
+	 nb_inst_memory                                ,
+
 	 size_write_queue                              ,
 	 size_execute_queue                            ,
@@ -279,7 +357,10 @@
 	 read_unit_to_execution_unit_priority          ,
 	 read_unit_to_execution_unit_table_routing     ,
-	 read_unit_to_execution_unit_table_thread      );
-      
-      msg(_("%s"),param->print(1).c_str());
+	 read_unit_to_execution_unit_table_thread      ,
+
+         is_load_store_unit                            , //[nb_execute_unit]
+         translate_num_execute_unit                    , //[nb_execute_unit]
+         true // is_toplevel
+         );
       
       test (name,param);
@@ -287,10 +368,10 @@
   catch (morpheo::ErrorMorpheo & error)
     {
-      msg (_("<%s> : %s.\n"),name.c_str(), error.what ());
+      msg (_("%s\n"),error.what ());
       exit (EXIT_FAILURE);
     }
   catch (...)
     {
-      err (_("<%s> : This test must generate a error.\n"),name.c_str());
+      err (_("This test must generate a error.\n"));
       exit (EXIT_FAILURE);
     }
